package model;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;



public class Person implements Comparable<Person>{
	
	private static final DateFormat F = new SimpleDateFormat("d.M.yyyy");
	
	private String anrede;
	private String vorname;
	private String nachname;
	private String strasse;
	private int plz;
	private String ort;
	private String telefon;
	private String mobil;
	private String eMail;
	private Date geburtstag;
	private boolean newsletter;
	
	protected Person(String[] record){
		this(record[1], record[2], record[3], record[4], record[5], record[6], 
				record[7], record[8], record[9], record[10], record[11]);
	}
	
	
	public Person(String anrede, String vorname, String nachname, String geburtstag, 
			String strasse, String plz, String ort, String telefon, String mobil,
			String eMail, String newsletter) {

		this.anrede = anrede;
		this.vorname = vorname;
		this.nachname = nachname;
		this.strasse = strasse;
		this.plz = Integer.parseInt(plz);
		this.ort = ort;
		this.telefon = telefon;
		this.mobil = mobil;
		this.eMail = eMail;
		try {
			this.geburtstag = F.parse(geburtstag);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		this.newsletter = newsletter.equalsIgnoreCase("ja");
	}
	
	public String getKey(){
		return nachname + ", " + vorname;
	}


	public String getVorname() {
		return vorname;
	}


	public String getNachname() {
		return nachname;
	}


	public String getAnrede() {
		return anrede;
	}


	public String getStrasse() {
		return strasse;
	}


	public int getPlz() {
		return plz;
	}


	public String getOrt() {
		return ort;
	}


	public String getTelefon() {
		return telefon;
	}


	public String getMobil() {
		return mobil;
	}


	public String geteMail() {
		return eMail;
	}


	public Date getGeburtstag() {
		return geburtstag;
	}


	public boolean isNewsletter() {
		return newsletter;
	}


	@Override
	public int compareTo(Person p) {
		return this.getKey().compareTo(p.getKey());
	}
	
	public int compareTo(String nachname, String vorname) {
		String key = nachname + ", " + vorname;
		return this.getKey().compareTo(key);
	}
	
	public String toString(){
		return nachname + ", " + vorname + ": " + plz + "-" + ort + ", " + strasse +  ", ...";
	}

}
